import datetime, errno, json, os
import ogstosgf

def write_content(path, bs):
    try:
        os.makedirs(os.path.dirname(path))
    except OSError as exc:
        if exc.errno != errno.EEXIST:
            raise

    with open(path, "w") as f:
        f.write(bs)

BLACKLIST=[
    None,
    "",
    "unknown",
    # Large Bots
    "Natsu (Fuego)",
    "Billy (GnuGo lvl10)",
    "TheKid (GnuGo lvl1)",
    "Random Bot",
    "GNU Go Level 1",
    "Kugutsu",
]

with open("ogs_games_2013_to_2021-08.json", "r") as f:
    for line in f:
        obj = json.loads(line)

        a = ogstosgf.construct_sgf(obj)
        if not a:
            continue
        is_export, (black, white, date, game_id), sgf_content = a

        if not sgf_content:
            print(obj)
            continue
        
        base="sgfs-by-date" if is_export else "sgfs-uploaded"
        if date:
            output_filename = f"{base}/{date.year}/{str(date.month).zfill(2)}/{str(date.day).zfill(2)}/{game_id}-{black}-{white}.sgf"
            write_content(output_filename, sgf_content)
        else:
            output_filename = f"{base}/unknown/{game_id}-{black}-{white}.sgf"
            write_content(output_filename, sgf_content)
        if (not is_export) and white not in BLACKLIST:
            output_filename = f"sgfs-by-username/{white[:2].lower()}/{white.lower()}/{game_id}-{black}-{white}.sgf"
            write_content(output_filename, sgf_content)
        if (not is_export) and black not in BLACKLIST:
            output_filename = f"sgfs-by-username/{black[:2].lower()}/{black.lower()}/{game_id}-{black}-{white}.sgf"
            write_content(output_filename, sgf_content)
